/*
 * CategoryView.h
 *
 *  Created on: 21.12.2009
 *      Author: apoi
 */

#ifndef CATEGORYVIEW_H_
#define CATEGORYVIEW_H_

#include <QMap>
#include <QVBoxLayout>

#include "MDragWidget.h"
#include "wpcustomviewbasicdata.h"

class QPushButton;
class QVBoxLayout;

class BlogView;
class CheckableListItem;
class WPDataBlog;
class WPDataCategory;
class WPScrollArea;

class CategoryView : public MDragWidget, public WPCustomViewBasicData
{
    Q_OBJECT
    
public:
    CategoryView(BlogView *aBlogview, QWidget * aParent = 0);
    ~CategoryView();

public:
    bool MDragWidgetIsDragging() const;
    QSize VisibleSize() const;
    void setFocus();

signals:
    void NewCategory (QString categoryName);

public slots:
    void UpdateCategoryData(const WPDataBlog& aBlog);
    void SelectCategories(const QStringList* aCategories);

private:
    const WPDataCategory* GetCategoryByName(const QString& aCategoryName);
    void SelectCategory(const QString& aCategoryId);
    void ClearSelection();
    void CreateListItem(const QString& aItemId, int aCategoryLevel, QMap<QString, QStringList*>& aChildMap);
    void ClearLayout(QLayout*);

private slots:
    void SaveSelection();
    void AddCategory();
    void CloseView();

private:
    BlogView* iBlogview;
    WPScrollArea* iScrollArea;
    QVBoxLayout* iLayout;

    QMap<QString, CheckableListItem*> iWidgetMap;
    QMap<QString, const WPDataCategory*> iCategoryMap;
    QStringList iCurrentSelection;
    QStringList iOriginalSelection;

    QString iNewCategory;
};

#endif /* CATEGORYVIEW_H_ */
