/*
 * ErrorDialog.h
 *
 *  Created on: 5.1.2010
 *      Author: apoi
 */

#include <QSize>
#include <QDesktopWidget>

#include "DialogController.h"
#include "ErrorDialog.h"

ErrorDialog::ErrorDialog(QWidget *aParent, DialogController *aDialog) : QDialog(aParent)
{
#ifdef Q_WS_MAEMO_5
    setWindowFlags(Qt::Dialog);
#else
    setWindowFlags(Qt::Popup);
#endif
    ui.setupUi(this);

    iDialog = aDialog;
    
    connect(ui.pushButton, SIGNAL(clicked()), this, SLOT(AcceptError())); 
}

ErrorDialog::~ErrorDialog()
{
}

void ErrorDialog::ShowErrorNote(const QString& aError)
{
    ui.errorNote->setText(aError);
}

void ErrorDialog::AcceptError()
{
    iDialog->ErrorAccepted();
}

void ErrorDialog::MoveAndShow()
{
    QSize parentSize = QApplication::desktop()->screenGeometry().size();
    show();
    move((parentSize.width() - width()) / 2, (parentSize.height() - height()) / 2);
}

void ErrorDialog::SetTitle(const QString& aTitle)
{
    ui.titleLabel->setText(aTitle);
}
