/*
 * PagesView.h
 *
 *  Created on: 4.11.2009
 *      Author: thyv
 */

#ifndef PAGESVIEW_H_
#define PAGESVIEW_H_

#include <QGraphicsWidget>
#include <QGraphicsView>

#include "collectionlist.h"
#include "WPData.h"

class BlogView;
class WPScrollArea;
class WPPageGraphicsList;
class QGraphicsLinearLayout;
class PannableView;

class PagesView : public QGraphicsWidget
{
    Q_OBJECT

public:
    PagesView(BlogView* aParent, const QGraphicsView& aGraphicsView, PannableView* aPannableView);
    ~PagesView();

    void setFocus();

public slots:
    void UpdatePageData(const WPDataBlog& aBlog);
    
signals:
    void OpenClicked(WPPage);
    void EditClicked(WPPage);
    
private:
    void resizeEvent(QGraphicsSceneResizeEvent *event);

private:
    BlogView* iParent;
    const QGraphicsView& iGraphicsView;
    WPPageGraphicsList* iListbox;
    QGraphicsLinearLayout* iLayout;
    PannableView* iPannableView;
};

#endif /* PAGESVIEW_H_ */
