/*
 * PostsView.h
 *
 *  Created on: 4.11.2009
 *      Author: thyv
 */

#ifndef POSTSVIEW_H_
#define POSTSVIEW_H_

#include <QGraphicsWidget>

//#include "collectionlist.h"
#include "BlogView.h"
#include "WPData.h"

class BlogView;
class WPScrollArea;
class WPPageGraphicsList;
class QGraphicsLinearLayout;
class QGraphicsSceneResizeEvent;
class WPPostGraphicsList;
class PannableView;

class PostsView : public QGraphicsWidget
{
    Q_OBJECT

public:
    PostsView(BlogView* aParent, const QGraphicsView& aGraphicsView, PannableView* aPannableView);
    ~PostsView();
    
public:
    void setFocus();
    
public slots:	
    void UpdatePostData(const WPDataBlog& aBlog);
    
signals:
    void OpenClicked(WPPost aPost);
    void EditClicked(WPPost aPost);
    void DeleteClicked(WPPost aPost);

private:
    void resizeEvent(QGraphicsSceneResizeEvent *e);

private:
    BlogView* iParent;
    const QGraphicsView& iGraphicsView;
    WPPostGraphicsList* iListbox;
    QGraphicsLinearLayout* iLayout;
    PannableView* iPannableView;
};

#endif /* POSTSVIEW_H_ */
