/*
 * ProgressDialog.cpp
 *
 *  Created on: 18.12.2009
 *      Author: apoi
 */

#include <QDesktopWidget>

#include "DialogController.h"
#include "ProgressDialog.h"

ProgressDialog::ProgressDialog(QWidget *aParent, DialogController *aDialog, bool cancelable) : QDialog(aParent)
{
#ifdef Q_WS_MAEMO_5
    setWindowFlags(Qt::Dialog);
#else
    setWindowFlags(Qt::Popup);
#endif

    ui.setupUi(this);
    ui.titleLabel->setText(tr("Please wait"));
    iDialog = aDialog;
    connect(ui.pushButton, SIGNAL(clicked()), iDialog, SLOT(ExitProgress()));
    
    if(cancelable)
        ui.pushButton->setText(tr("Cancel"));
}

ProgressDialog::~ProgressDialog()
{
}

void ProgressDialog::MoveAndShow()
{
    QSize parentSize = QApplication::desktop()->screenGeometry().size();
    show();
    move((parentSize.width() - width()) / 2, (parentSize.height() - height()) / 2);
}

void ProgressDialog::SetAction(const QString& aAction)
{
    ui.actionLabel->setText(aAction);
}
