/*
 * apikeydialog.cpp
 *
 *  Created on: 15.3.2010
 *      Author: aahv
 */

#include <QPushButton>
#include <QMessageBox>

#include "apikeydialog.h"
#include "ui_apikeydialog.h"

ApiKeyDialog::ApiKeyDialog(QWidget *parent) :
        QDialog(parent),
        ui(new Ui::ApiKeyDialog)
{
#ifdef Q_WS_MAEMO_5
    setWindowFlags(Qt::Dialog);
#else
    setWindowFlags(Qt::Popup);
#endif

    ui->setupUi(this);

    ui->apiKeyText->SetExplanation(tr("API key"));

    setModal(true);
    
    connect(ui->okButton, SIGNAL(clicked()), this, SLOT(onOk()));
    connect(ui->cancelButton, SIGNAL(clicked()), this, SLOT(onCancel()));    
}

ApiKeyDialog::~ApiKeyDialog()
{
    delete ui;
}

void ApiKeyDialog::changeEvent(QEvent *e)
{
    QDialog::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void ApiKeyDialog::onOk() {
    QString str = ui->apiKeyText->text().trimmed();
    if (str.length() == 12) {
        ui->apiKeyText->Clear();
        emit setApiKey(str);
        accept();
    } else {
        QMessageBox::warning(this, tr("Invalid API key"), tr("Invalid API key. It must be 12 characters long."), QMessageBox::Close, QMessageBox::Close);
    }
}

void ApiKeyDialog::onCancel() {
    ui->apiKeyText->Clear();
    reject();
}
