#ifndef COMMENTSVIEW_H
#define COMMENTSVIEW_H

#include <QGraphicsWidget>
#include <QGraphicsView>

class QGraphicsLinearLayout;

class BlogView;
class CommentsGraphicsView;
class WPDataBlog;
class WPCommentGraphicsList;
class WPScrollArea;
class PannableView;

class CommentsView : public QGraphicsWidget
{
    Q_OBJECT

public:
    CommentsView(BlogView* parent, const QGraphicsView& aGraphicsView, PannableView* aPannableView);
    ~CommentsView();
    
public slots:	
    void UpdateCommentsData(const WPDataBlog& aBlog);
    void resizeEvent(QGraphicsSceneResizeEvent *e);
    void setFocus();

private:
    BlogView* iParent;
    const QGraphicsView& iGraphicsView;
    WPCommentGraphicsList* iListbox;
    QGraphicsLinearLayout* iLayout;
    PannableView* iPannableView;
};

#endif // COMMENTSVIEW_H
