#ifndef WPCOMMENTGRAPHICSLISTITEM_H
#define WPCOMMENTGRAPHICSLISTITEM_H

#include "wpgraphicslistitem.h"
#include "WPData.h"

class QPixmap;
class WPCommentGraphicsList;
class BusyIndicator;

class WPCommentGraphicsListItem : public WPGraphicsListItem
{
    Q_OBJECT

public:
    WPCommentGraphicsListItem(WPComment aComment, 
        bool aShowFullComment, BusyIndicator& aBusyIndicator, ThemeData& aThemeData);
    ~WPCommentGraphicsListItem();
    
public: // New functions
    void SetAvatarImage(const QPixmap &aPixmap);
    WPComment GetComment() const;
    void ChangeViewMode();
    bool ShowFullComment() const { return iShowFullComment; };
    void Update (WPComment aComment);
    
public: // WPGraphicsListItem implementation
    void paintContent(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget = 0);
    bool IsBusy();
    bool HasError();
    void handleGeomeryChange();

private:
    void calculateElidedTexts();
    void SetViewMode(bool aShowFullComment);
    
private: // Data
    WPComment iComment;
    
    bool iShowFullComment;
    int iPicWidth;
    int iPicHeight;
    int iCol2ContentXOffset;

    QPixmap iPixmap;
    QString iDate;
    QString iTitle;
    QString iCommentText;

    QRect iTitleSize;
    QRect iCommentSize;
    
    int iHeight;
};

#endif // WPCOMMENTGRAPHICSLISTITEM_H
