/*
 * wpcollectiongraphicslist.h
 *
 *  Created on: 19.5.2010
 *      Author: jlep
 */

#ifndef WPPAGEGRAPHICSLIST_H_
#define WPPAGEGRAPHICSLIST_H_

#include <QGraphicsWidget>
#include <QGraphicsView>
#include <QList>

#include "wpgraphicslist.h"
#include "WPData.h"

class QLabel;
class QPushButton;

class PopupMenu;
class PageGraphicsView;
class WPGraphicsListItem;
class WPPageGraphicsListItem;
class QGraphicsProxyWidget;
class BlogView;

class WPPageGraphicsList : public WPGraphicsList
{
    Q_OBJECT

public:

    WPPageGraphicsList(QListIterator<WPPage> aPages, const QGraphicsView& aGraphicsView,
        BlogView* aBlogView, PannableView* aPannableView);
    ~WPPageGraphicsList();

public slots:
    void PageChanged(WPPage aPage);
    void PageRemoved(WPPage aPage);
    void PageAdded(WPPage aPage);

signals:
    void OpenClicked(WPPage aPage);
    void EditClicked(WPPage aPage);
    
private:
    void AddPage(WPPage aPage);
    void RemovePage (WPPage aPage);
   
    void SetLabelText();
    
    void DecrementDrafts();
    void DecrementPages();
    
    void IncrementDrafts();
    void IncrementPages();
    
private: // WPGraphicsList implementation
    void PopulatePopupMenuForCurrentItem(PopupMenu* aPopupMenu);
    int FirstFocusableItemIndex() { return 2; }
    
private:
    // Ugly workarounds because QObject does not support templates...
    WPPageGraphicsListItem * ItemAt(int i) 
    	{ return reinterpret_cast<WPPageGraphicsListItem *> (iItems[i]); }
    WPPageGraphicsListItem * CurrentItem()
        { return reinterpret_cast<WPPageGraphicsListItem *> (iCurrentItem); }

private slots:
    void Open();
    void Edit();
    void Delete();

private: // Data
    QString iTitle;

    QLabel* iDraftsLabel;
    QGraphicsProxyWidget* iDraftsProxy;
    QLabel* iPagesLabel;
    QGraphicsProxyWidget* iPagesProxy;
    int iDrafts;
    int iPages;

    QAction* iActionOpen;
    QAction* iActionEdit;
    QAction* iActionDelete;
    
    QPushButton* iNewPageButton;
    QGraphicsProxyWidget* iNewPageProxy;
};

#endif /* WPPAGEGRAPHICSLIST_H_ */
