/*
 * wppostgraphicslist.h
 *
 *  Created on: 19.5.2010
 *      Author: jlep
 */

#ifndef WPPOSTGRAPHICSLIST_H_
#define WPPOSTGRAPHICSLIST_H_

#include "wpgraphicslist.h"
#include "WPData.h"

class QLabel;
class QPushButton;
class WPPostGraphicsListItem;
class WPGraphicsListItem;

class PostGraphicsView;
class QGraphicsProxyWidget;
class BlogView;

class WPPostGraphicsList  : public WPGraphicsList
{
    Q_OBJECT

public:
    WPPostGraphicsList (QListIterator<WPPost> aPosts, const QGraphicsView& aGraphicsView, 
        BlogView* aBlogView, PannableView* aPannableView);
    ~WPPostGraphicsList();

public slots:
    void PostChanged(WPPost aPost);
    void PostRemoved(WPPost aPost);
    void PostAdded(WPPost aPost);
    
signals:
    void OpenClicked(WPPost aPost);
    void EditClicked(WPPost aPost);
    void DeleteClicked(WPPost aPost);
    
private:
    void AddPost(WPPost aPost);
    void RemovePost (WPPost aPost);

    void SetLabelText();
    
    void DecrementDrafts();
    void DecrementPosts();
    
    void IncrementDrafts();
    void IncrementPosts();
    
private: // WPGraphicsList implementation
    void PopulatePopupMenuForCurrentItem(PopupMenu* aPopupMenu);
    int FirstFocusableItemIndex() { return 2; }
    
private:
    // Ugly workarounds because QObject does not support templates...
    WPPostGraphicsListItem * ItemAt(int i) 
    	{ return reinterpret_cast<WPPostGraphicsListItem *> (iItems[i]); }
    WPPostGraphicsListItem * CurrentItem()
        { return reinterpret_cast<WPPostGraphicsListItem *> (iCurrentItem); }

private slots:
    void Open();
    void Edit();
    void Delete();
   
private: // Data
    QString iTitle;
    
    QLabel* iDraftsLabel;
    QGraphicsProxyWidget* iDraftsProxy;
    QLabel* iPostsLabel;
    QGraphicsProxyWidget* iPostsProxy;
    int iDrafts;
    int iPosts;
    
    QAction* iActionOpen;
    QAction* iActionEdit;
    QAction* iActionDelete;
    int iStretchCount;
    
    QPushButton* iNewPostButton;
    QGraphicsProxyWidget* iNewPostProxy;
    
    QGraphicsProxyWidget* iMenuProxy;
};

#endif /* WPPOSTGRAPHICSLIST_H_ */
