#ifndef WPTABBEDLISTVIEW_H
#define WPTABBEDLISTVIEW_H

#include "wpgraphicsview.h"

#include <QGraphicsLinearLayout>

class BlogView;
class WPTabbarGraphicsView;
class WPStackedGraphicsWidget;

class PannableView;

class PostsView;
class PagesView;
class CommentsView;

/**
 * The central comment/post/page list widget.
 *
 * Implemented using QGraphics.
 */
class WPTabbedListView : public WPGraphicsView
{
public:    
    WPTabbedListView (BlogView *blogView);

    /** XXX: wut */    
    void switchPreviousWidget ();
    void setFocus ();

protected:
    /** Switch tabs on left/right key nav */
    void keyReleaseEvent (QKeyEvent *event);

public: /* XXX: for signals */
    /** Tab menu widget */
    WPTabbarGraphicsView* iTabBarWidget;

    /** Switchable tab content */
    WPStackedGraphicsWidget* iTabContentWidget;
    
    /** Main layout for tab bar/content */
    QGraphicsLinearLayout*  iTabLayout;

    /* The various tabs */
    PostsView* iPostsView;
    PannableView* iPannablePostsWidget;

    PagesView* iPagesView;
    PannableView* iPannablePagesWidget;

    CommentsView* iCommentsView;
    PannableView* iPannableCommentsWidget;
};

#endif
